diff --git a/spring-boot-tools/spring-boot-loader/src/main/java/org/springframework/boot/loader/LaunchedURLClassLoader.java b/spring-boot-tools/spring-boot-loader/src/main/java/org/springframework/boot/loader/LaunchedURLClassLoader.java
index 80ed0ca583f..533d67665d1 100644
--- a/spring-boot-tools/spring-boot-loader/src/main/java/org/springframework/boot/loader/LaunchedURLClassLoader.java
+++ b/spring-boot-tools/spring-boot-loader/src/main/java/org/springframework/boot/loader/LaunchedURLClassLoader.java
@@ -82,7 +82,13 @@ public URL findResource(String name) {
 			if (name.equals("") && hasURLs()) {
 				return getURLs()[0];
 			}
-			return super.findResource(name);
+			Handler.setUseFastConnectionExceptions(true);
+			try {
+				return super.findResource(name);
+			}
+			finally {
+				Handler.setUseFastConnectionExceptions(false);
+			}
 		}
 		catch (IllegalArgumentException ex) {
 			return null;
@@ -94,7 +100,13 @@ public URL findResource(String name) {
 		if (name.equals("") && hasURLs()) {
 			return Collections.enumeration(Arrays.asList(getURLs()));
 		}
-		return super.findResources(name);
+		Handler.setUseFastConnectionExceptions(true);
+		try {
+			return super.findResources(name);
+		}
+		finally {
+			Handler.setUseFastConnectionExceptions(false);
+		}
 	}
 
 	private boolean hasURLs() {
@@ -291,6 +303,6 @@ public URL nextElement() {
 			return this.localResources.nextElement();
 		}
 
-	};
+	}
 
 }
